## Copyright (C) 2006 SWsoft
## All rights reserved.
## MT class for domain plug-ins
package HSPC::MT::PluginConfig::DM;

use strict;
use HSPC::MT::PluginConfig;

use vars qw(@ISA);
@ISA = qw( HSPC::MT::PluginConfig );

use constant CLASS_INFO => {
	props => {
		'id' => {
			col   => 'id',
			table => 'plugin',
			key   => 'AUTO',
			type  => 'int',
		},
		'currency' => {
			col   => 'currency',
			table => 'plugin_dm',
			type  => 'char',
		},
	},
	tables => {
		'plugin' => {
			name => 'plugin',
			replace => 1
		},
		'plugin_dm' => {
			name       => 'plugin_dm',
			rel_table  => 'plugin',
			join_where => 'plugin.id = plugin_dm.config_id',
		},
	},
};

sub list {
	my $self = shift;
	my %h = (
		'attributes' => undef,
		'filter' => undef,
		@_,
	);

	my $filter = $h{'filter'} || {};

	if (!defined($filter->{'plugin_type'})) {
		$filter->{'plugin_type'} = 'DM';
	}

	return $self->SUPER::list(attributes=>$h{'attributes'},filter=>$filter);
}

sub find_plugin {
	my $self = shift;
	my %h = (
		## for domain plug-ins typically this flags should be enabled
		force_activity          => 1,
		force_template_existing => 1,
		@_
	);
	
	return $self->SUPER::find_plugin(%h);
}

sub process_config_data {
	my $self = shift;
	my %h = (
		callback_email => undef,
		@_
	);
	my $callback_email = $h{callback_email};
	my $result = {is_success => 1};

	if(defined($callback_email)){
##		use HSPC::DM::Gate;
##		$result = HSPC::DM::Gate->create_alias(
##			plugin_id => $self->id(),
##			email => $callback_email,
##		);
		return $result if(!$result->{is_success});

## TODO: Add mail logging
##
##		HSPC::MT::Core::Tools->register_mail_handler(
##			type_id		=>"HSPC::MT::DM::Plugin::Nominet",
##			name_id		=>"dm_plugin_nominet_title",
##			class		=>'HSPC::MT::DM::RegEngine',
##			method		=>'get_plugin',
##			alias		=>'domain_plugin_nominet_tab_general',
##			uri_params	=>'plugin,',
##			direction	=> &HSPC::MT::Core::EMail::OUT | &HSPC::MT::Core::EMail::IN,
##		);
	}

	return $result;
}

1;
